#!/usr/bin/env groovy

def call(body) {
    def config = [:]
    println "Before: ${config.name}"
    body.resolveStrategy = Closure.DELEGATE_FIRST
    body.delegate = config
    println body()

    println "After: ${config.name}"
    echo body.name
    echo "Param1 is: ${env.param1}"
    echo "Param2 is: ${env.param2}"
    if (env.param1 == 'One default') {
        echo "Param1 is default"
    }
    println "Class: ${this.class.name}"
    return this
}
